#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_NoviceGrowthCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_NoviceGrowthCFG> M_NoviceGrowthCFG::msSingleton(nullptr);

int M_NoviceGrowthCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_NoviceGrowthCFGData* M_NoviceGrowthCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_NoviceGrowthCFGData>& M_NoviceGrowthCFG::GetMapData()
{
	return mMapData;
}

void M_NoviceGrowthCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_NoviceGrowthCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_NoviceGrowthCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGroup = element->IntAttribute("Group");
		data.mName = element->Attribute("Name");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* ShowItem = element->Attribute("ShowItem");
			std::vector<std::string> vecShowItem;
			boost::split(vecShowItem, ShowItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowItem[i].c_str(), &temp))
				{
					data.mShowItem.push_back(temp);
				}
			}
		}
		{
			const char* ShowNumber = element->Attribute("ShowNumber");
			std::vector<std::string> vecShowNumber;
			boost::split(vecShowNumber, ShowNumber, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowNumber[i].c_str(), &temp))
				{
					data.mShowNumber.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_NoviceGrowthCFG::Load()
{
	Load("../Config/M_NoviceGrowthCFG.xml");
}

M_NoviceGrowthCFG* M_NoviceGrowthCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_NoviceGrowthCFG());
	}
	return msSingleton.get();
}
